use enumer generate tool for state strings

This commit is contained in:
Christian Schwarz 2018-10-12 22:10:49 +02:00
parent 89e0103abd
commit af3d96dab8
8 changed files with 172 additions and 77 deletions

View File

@ -252,7 +252,13 @@ func (t *tui) renderReplicationReport(rep *replication.Report) {
return all[i].Filesystem < all[j].Filesystem
})
t.printf("Status: %s", rep.Status)
state, err := replication.StateString(rep.Status)
if err != nil {
t.printf("Status: %q (parse error: %q)\n", rep.Status, err)
return
}
t.printf("Status: %s", state)
t.newline()
if rep.Problem != "" {
t.printf("Problem: %s", rep.Problem)
@ -261,8 +267,8 @@ func (t *tui) renderReplicationReport(rep *replication.Report) {
if rep.SleepUntil.After(time.Now()) {
t.printf("Sleeping until %s (%s left)\n", rep.SleepUntil, rep.SleepUntil.Sub(time.Now()))
}
if rep.Status != replication.Planning.String() &&
rep.Status != replication.PlanningError.String() {
if state != replication.Planning && state != replication.PlanningError {
// Progress: [---------------]
sumUpFSRep := func(rep *fsrep.Report) (transferred, total int64) {
for _, s := range rep.Pending {
@ -304,7 +310,13 @@ func (t *tui) renderPrunerReport(r *pruner.Report) {
return
}
t.printf("Status: %s", r.State)
state, err := pruner.StateString(r.State)
if err != nil {
t.printf("Status: %q (parse error: %q)\n", r.State, err)
return
}
t.printf("Status: %s", state)
t.newline()
if r.Error != "" {

View File

@ -151,7 +151,7 @@ func (f *PrunerFactory) BuildReceiverPruner(ctx context.Context, target Target,
return p
}
//go:generate stringer -type=State
//go:generate enumer -type=State
type State int
const (

View File

@ -0,0 +1,76 @@
// Code generated by "enumer -type=State"; DO NOT EDIT.
package pruner
import (
"fmt"
)
const (
_StateName_0 = "PlanPlanWait"
_StateName_1 = "Exec"
_StateName_2 = "ExecWait"
_StateName_3 = "ErrPerm"
_StateName_4 = "Done"
)
var (
_StateIndex_0 = [...]uint8{0, 4, 12}
_StateIndex_1 = [...]uint8{0, 4}
_StateIndex_2 = [...]uint8{0, 8}
_StateIndex_3 = [...]uint8{0, 7}
_StateIndex_4 = [...]uint8{0, 4}
)
func (i State) String() string {
switch {
case 1 <= i && i <= 2:
i -= 1
return _StateName_0[_StateIndex_0[i]:_StateIndex_0[i+1]]
case i == 4:
return _StateName_1
case i == 8:
return _StateName_2
case i == 16:
return _StateName_3
case i == 32:
return _StateName_4
default:
return fmt.Sprintf("State(%d)", i)
}
}
var _StateValues = []State{1, 2, 4, 8, 16, 32}
var _StateNameToValueMap = map[string]State{
_StateName_0[0:4]: 1,
_StateName_0[4:12]: 2,
_StateName_1[0:4]: 4,
_StateName_2[0:8]: 8,
_StateName_3[0:7]: 16,
_StateName_4[0:4]: 32,
}
// StateString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func StateString(s string) (State, error) {
if val, ok := _StateNameToValueMap[s]; ok {
return val, nil
}
return 0, fmt.Errorf("%s does not belong to State values", s)
}
// StateValues returns all values of the enum
func StateValues() []State {
return _StateValues
}
// IsAState returns "true" if the value is listed in the enum definition. "false" otherwise
func (i State) IsAState() bool {
for _, v := range _StateValues {
if i == v {
return true
}
}
return false
}

View File

@ -1,35 +0,0 @@
// Code generated by "stringer -type=State"; DO NOT EDIT.
package pruner
import "strconv"
const (
_State_name_0 = "PlanPlanWait"
_State_name_1 = "Exec"
_State_name_2 = "ExecWait"
_State_name_3 = "ErrPerm"
_State_name_4 = "Done"
)
var (
_State_index_0 = [...]uint8{0, 4, 12}
)
func (i State) String() string {
switch {
case 1 <= i && i <= 2:
i -= 1
return _State_name_0[_State_index_0[i]:_State_index_0[i+1]]
case i == 4:
return _State_name_1
case i == 8:
return _State_name_2
case i == 16:
return _State_name_3
case i == 32:
return _State_name_4
default:
return "State(" + strconv.FormatInt(int64(i), 10) + ")"
}
}

View File

@ -30,7 +30,8 @@ builddep() {
go get -u golang.org/x/tools/cmd/stringer
go get -u github.com/golang/dep/cmd/dep
go get -u github.com/golang/protobuf/protoc-gen-go
if ! type stringer || ! type dep || ! type protoc-gen-go; then
go get -u github.com/alvaroloes/enumer
if ! type stringer || ! type dep || ! type protoc-gen-go; || ! type enumer then
echo "Installed dependencies but can't find them in \$PATH, adjust it to contain \$GOPATH/bin" 1>&2
exit 1
fi

View File

@ -18,7 +18,7 @@ import (
"github.com/zrepl/zrepl/replication/pdu"
)
//go:generate stringer -type=State
//go:generate enumer -type=State
type State uint
const (

View File

@ -0,0 +1,76 @@
// Code generated by "enumer -type=State"; DO NOT EDIT.
package replication
import (
"fmt"
)
const (
_StateName_0 = "PlanningPlanningError"
_StateName_1 = "Working"
_StateName_2 = "WorkingWait"
_StateName_3 = "Completed"
_StateName_4 = "ContextDone"
)
var (
_StateIndex_0 = [...]uint8{0, 8, 21}
_StateIndex_1 = [...]uint8{0, 7}
_StateIndex_2 = [...]uint8{0, 11}
_StateIndex_3 = [...]uint8{0, 9}
_StateIndex_4 = [...]uint8{0, 11}
)
func (i State) String() string {
switch {
case 1 <= i && i <= 2:
i -= 1
return _StateName_0[_StateIndex_0[i]:_StateIndex_0[i+1]]
case i == 4:
return _StateName_1
case i == 8:
return _StateName_2
case i == 16:
return _StateName_3
case i == 32:
return _StateName_4
default:
return fmt.Sprintf("State(%d)", i)
}
}
var _StateValues = []State{1, 2, 4, 8, 16, 32}
var _StateNameToValueMap = map[string]State{
_StateName_0[0:8]: 1,
_StateName_0[8:21]: 2,
_StateName_1[0:7]: 4,
_StateName_2[0:11]: 8,
_StateName_3[0:9]: 16,
_StateName_4[0:11]: 32,
}
// StateString retrieves an enum value from the enum constants string name.
// Throws an error if the param is not part of the enum.
func StateString(s string) (State, error) {
if val, ok := _StateNameToValueMap[s]; ok {
return val, nil
}
return 0, fmt.Errorf("%s does not belong to State values", s)
}
// StateValues returns all values of the enum
func StateValues() []State {
return _StateValues
}
// IsAState returns "true" if the value is listed in the enum definition. "false" otherwise
func (i State) IsAState() bool {
for _, v := range _StateValues {
if i == v {
return true
}
}
return false
}

View File

@ -1,35 +0,0 @@
// Code generated by "stringer -type=State"; DO NOT EDIT.
package replication
import "strconv"
const (
_State_name_0 = "PlanningPlanningError"
_State_name_1 = "Working"
_State_name_2 = "WorkingWait"
_State_name_3 = "Completed"
_State_name_4 = "ContextDone"
)
var (
_State_index_0 = [...]uint8{0, 8, 21}
)
func (i State) String() string {
switch {
case 1 <= i && i <= 2:
i -= 1
return _State_name_0[_State_index_0[i]:_State_index_0[i+1]]
case i == 4:
return _State_name_1
case i == 8:
return _State_name_2
case i == 16:
return _State_name_3
case i == 32:
return _State_name_4
default:
return "State(" + strconv.FormatInt(int64(i), 10) + ")"
}
}